;$Id: trifenestra_command_line.pro,v 1.3 2002/05/20 03:41:18 jmspark Exp $

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::_message, text

	message, text, /continue

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::_help


	for i = 0, n_elements( !trifenestra.available_cmds ) - 1 do begin

		self -> _log, current_cmds[i]

	endfor

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function trifenestra::command_execute, text

	self -> _log, 'Trifenestra > ' + text
	!trifenestra.CommandTrash -> push, text

	if strtrim( text, 1 ) eq ''	$
		or stregex( strtrim( text, 1 ) , '^#', /boolean ) then $
		return, 1

	split_text = strsplit( text, ',', /extract )
	cmd = split_text[0]

	; No such command.
	if ( where( !trifenestra.available_cmds eq cmd ) )[0] eq -1 then begin

		self -> _log, 'Error: No such command exists.'
		return, 1

	endif

	return, execute( 'self -> _' + text )

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::command_process_que

	while !trifenestra.CommandQueue -> full() do begin
		text = !trifenestra.CommandQueue -> shift()
		if not self -> command_execute( text ) then begin
			self -> _log, 'Error: Failed to execute the command.'
		endif
	endwhile

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::command_line2que, text

	!trifenestra.CommandQueue -> push, text

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::command_line, event

	widget_control, event.id, get_value = text
	widget_control, event.id, set_value = ''

	; if float(!version.release) le 5.4 then text = text[0]
	text = strjoin( text, /single )

	self -> command_line2que, text
	self -> command_process_que

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function trifenestra_command_line, base

	wBase = widget_base( base $

		, event_pro = 'trifenestra_event' )

	wID = cw_field( wBase $
		, /row $
		, /string $
		, /return_events $
		, title = 'Trifenestra > ' $
		, uvalue = 'command_line' $
		, uname = 'trifenestra_command_line' $
		, xsize = 80 $
		, ysize = 1 $
		)


	return, wID

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************